;;;;;;;INITIALIZATION START;;;;;;;;{
;####################################################
	
	;[Load Vars, Settings and Functions] ;{
	;----------------------------------------------
		#NoEnv
		#SingleInstance, force
		SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
		SetBatchLines -1
		SetWinDelay, 0
		XP_MODE:=0
		
		if A_OSVersion in WIN_NT4,WIN_95,WIN_98,WIN_ME,WIN_2003,WIN_XP,WIN_2000
		{
			XP_MODE:=1
			MsgBox,64,UFCPP - Important Note
				,This script is for Windows Vista, 7 or later.`nWindows XP already supports Fullscreen CMD.`nThe program will now exit.
			ExitApp
		}
		
		;FileInstall, SizeCon.dll, %A_Temp%\SizeCon.dll, 1
		FileInstall, res/joedf-logo.png, %A_Temp%\joedf-logo.png, 1
		FileInstall, res/cmdicon_x48.png, %A_Temp%\cmdicon_x48.png, 1
		SplitPath, A_ScriptName,,,,scriptnamenoext
		configfile=%A_ScriptDir%\%scriptnamenoext%.ini
		UpdateCheckLocation=http://ufcpp.sourceforge.net/update/update.txt
		AppName=UFCPP
		version=2.8.4
		cmdfullscreen := 0
		OnExit, exitprgm
		
		IniRead,Screenbuffer_lines, %configfile%, UFCPP_Settings, Screenbuffer_lines, 300
		IniRead,Show_Scrollbar, %configfile%, UFCPP_Settings, Show_Scrollbar, 0
		IniRead,MaxButtonFS, %configfile%, UFCPP_Settings, MaxButtonFS, 1
		IniRead,setwindowwatch, %configfile%, UFCPP_Settings, Block_FS_NotSupported_Window, 1
		IniRead,OpenCMDKey_enabled, %configfile%, UFCPP_Settings, OpenCMDKey_enabled, 1
		IniRead,OpenCMDKey, %configfile%, UFCPP_Settings, OpenCMDKey,^#c
		IniRead,FSKey_enabled, %configfile%, UFCPP_Settings, FSKey_enabled, 1
		IniRead,FSKey, %configfile%, UFCPP_Settings, FSKey,!Enter
		IniRead,StartUp_Update_Check,%configfile%,UFCPP_Settings,StartUp_Update_Check, 0
		IniRead,UseAutoRun,%configfile%,UFCPP_Settings,UseAutoRun,0
		
		if (XP_MODE)
			setwindowwatch:=0
		
		#Include Lib\SizeConLib2.ahk 		;SizeConLib_VERSION = 2.0.0
		SizeConDebug := 1 ;Turn Debug/MsgError On...
		
		#Include Lib\HotkeyControl.ahk
		
info =
(
#############################################################
                 __  __ ____ _____ ___   ___ 
                / / / // __// ___// _ \ / _ \
               / /_/ // _/ / /__ / ___// ___/
               \____//_/   \___//_/   /_/    
        ____________________________________________
		
      The Unofficial Fullscreen Command Prompt Patcher
#############################################################
;
; UFCPP Version:      %version%
; AutoHotkey Version: %A_AhkVersion%
; Language:       English
; Dev Platform:   Windows 7 Home Premium x64
; Author:         Joe DF  |  joedf.co.nr  |  joedf@live.ca
; Date:           September 3rd, 2013
;
; Script page:
;	http://ufcpp.sourceforge.net
;
; Script Function:
;	Make Cmd Fullscreen with a Hotkey: Alt+Enter
;	  (Customizable)
;	+ Hotkey to open a new cmd window: Ctrl+LWin+C
;	  (Customizable)
;
; Special Thanks to:
;	DataLife, Lexikos, A_Samurai and Linear Spoon
;
;	This is FREE software and should not be sold.
; 	Selling is allowed, but it would be immoral... :P
;
; The MIT License (MIT)
;    Copyright  %A_YEAR% Joe DF (joedf@users.sourceforge.net)
;
; Permission is hereby granted, free of charge, to any person
; obtaining a copy of this software and associated
; documentation files (the Software), to deal in the
; Software without restriction, including without limitation
; the rights to use, copy, modify, merge, publish,
; distribute, sublicense, and/or sell copies of the Software,
; and to permit persons to whom the Software is furnished to
; do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall
; be included in all copies or substantial portions of the
; Software.
;
; THE SOFTWARE IS PROVIDED AS IS, WITHOUT WARRANTY OF ANY
; KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
; WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
; PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
; OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
; OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
; OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
)
	;----------------------------------------------;}

	;[Setup Tray Menu] ;{
	;---------------------------------------------
		menu, tray, NoStandard
		menu, tray, add, Open Command Prompt, cmdopen
		menu, tray, Default, Open Command Prompt
		menu, tray, add, Open Fullscreen Cmd, fscmdopen
		;menu, Submenu, add, Enable Open Cmd Hotkey (Ctrl+Lwin+C), CmdHotkey_handler
		menu, Submenu, add, Hotkey Settings, HotkeySettingGUI
		menu, Submenu, add, Block FS unsupported Message, setwindowwatchhandler
		menu, Submenu, add, Show Scrollbar, Show_Scrollbar_config
		menu, Submenu, add, Maximize Button to FullScreen, MaxButtonFS_config
		menu, Submenu, add, Screenbuffer Lines (%Screenbuffer_lines%), Screenbuffer_lines_config
		menu, Submenu, add, Check for updates on Start Up, StartUp_Update_Check_handler
		menu, Submenu, add, Check for updates, updatechk
		menu, Submenu, add, Run On Start Up (On Login), UseAutoRun_Config
		Menu, tray, add, Options, :Submenu
		Menu, tray, add  ; Add a separator line
		menu, tray, add, About, aboutinfo
		menu, tray, add, Reload, reloadprgm
		menu, tray, add, Quit, exitprgm
		
		if (XP_MODE)
			Menu, Submenu, Disable, Block FS unsupported Message
	;-----------------------------------------;}

	;[Handle Options from ConfigFile] ;{
	;---------------------------------------------
		If (Show_Scrollbar)
			menu, Submenu, Check, Show Scrollbar
		Else
			menu, Submenu, UnCheck, Show Scrollbar
			
		If (MaxButtonFS)
			menu, Submenu, Check, Maximize Button to FullScreen
		Else
			menu, Submenu, UnCheck, Maximize Button to FullScreen
			
		If (UseAutoRun)
			menu, Submenu, Check, Run On Start Up (On Login)
		Else
			menu, Submenu, UnCheck, Run On Start Up (On Login)
		
		Hotkey,%OpenCMDKey%,cmdopen
		If (!OpenCMDKey_Enabled)
			Hotkey,%OpenCMDKey%,,Off
		
		if (strlower(FSKey) != "!enter")
		{
			Hotkey,%FSKey%,runfscreenr
			if (!FSKey_Enabled)
				Hotkey,%FSKey%,Off
		}
			
		If (setwindowwatch)
			menu, Submenu, Check, Block FS unsupported Message
		else
			menu, Submenu, UnCheck, Block FS unsupported Message
		
		If (StartUp_Update_Check)
			menu, Submenu, Check, Check for updates On Start Up
		Else
			menu, Submenu, UnCheck, Check for updates On Start Up
	;----------------------------------------------;}

;;Check for update after initialization
If (StartUp_Update_Check)
	update_program(Appname,Version,UpdateCheckLocation,"Browser","true","false")
;;;;;;;;;;INITIALIZATION END;;;;;;;;;;;}

;[Hotkey Actions] ;{
;----------------------------------------------------
	#IfWinActive, ahk_class ConsoleWindowClass
	~$!Enter::
	if (strlower(FSKey) == "!enter") and (FSKey_Enabled)
	{
		KeyWait Enter
		KeyWait Alt
	}
	else
	{
		return
	}
	runfscreenr:
		;MsgBox %patched%
		IfWinActive, ahk_class ConsoleWindowClass
		{
			If (setwindowwatch)
			{
				SetTimer,WatchForWindow,10
			}
			
			if (!cmdfullscreen)
			{
				;"DllCall" Method, using SizeCon.dll
				WinGet,cPID,PID,ahk_class ConsoleWindowClass
				WinGetPos,wcx,wcy,wcw,wch,ahk_pid %cPID%
				;AttachConsole() http://msdn.microsof...ibrary/ms681952
				AttachConsole(cPID)
				;Get the console's window Handle
				hConsole := getConsoleHandle()
				;Get Console screen buffer handle, from Lexikos ; http://www.autohotke...er/#entry561509
				hStdout := getStdoutHandle()
				;Get BufferSize ... SizeCon.dll function
				bw := getConsoleWidth(hStdout)
				;bh := getConsoleHeight(hStdout)
				;Get Fontwidth, FontHeight, custom dll function
				fontwidth := getFontWidth(hStdout)
				fontheight := getFontHeight(hStdout)
				;Calculate Size
				getClientOffset(ty,bx,by,sby)
				If (Show_Scrollbar)
					cw := Round((A_ScreenWidth - sby) / Fontwidth)
				else
					cw := Round((A_ScreenWidth) / Fontwidth)
				ch := Screenbuffer_lines ;ch := A_ScreenHeight / Fontheight
				;set Console window size, custom dll function
				setConsoleSize(cw,ch,hStdout,hConsole)
				;Add Final FullScreen Settings
				xp_diff:=((XP_MODE) ? 0 : 7)
				fullw := A_ScreenWidth + 42
				fullh := A_ScreenHeight + ty + xp_diff
				WinMove, ahk_pid %cPID%,,-(bx+xp_diff),-(ty+by+xp_diff),%fullw%,%fullh%
				WinSet, AlwaysOnTop, on, ahk_pid %cPID%
				;FreeConsole() http://msdn.microsof...ibrary/ms683150
				FreeConsole()
				cmdfullscreen:=1
			}
			Else
			{
				;"DllCall" Method, using SizeCon.dll
				WinGet,cPID,PID,ahk_class ConsoleWindowClass
				AttachConsole(cPID)
				hConsole := getConsoleHandle()
				hStdout := getStdoutHandle()
				fontheight := getFontHeight(hStdout)
				ch := Screenbuffer_lines ;or (ch := bh)
				setConsoleSize(bw,ch,hStdout,hConsole)
				WinMove,ahk_pid %cPID%,,%wcx%,%wcy%,%wcw%,(wch-fontheight) ;(wch-fontheight) vs (wch) bug-fix size increases?!
				WinSet, AlwaysOnTop, Off, ahk_pid %cPID%
				FreeConsole()
				cmdfullscreen:=0
			}
		}
	Return

	::exit::
		BlockInput, on
		WinGet,currCMDoutEXIT_hwnd,ID,A
		Send, exit{enter}
		BlockInput, off
		FSCmdChk:=0
		SetTimer,FSCmdCheck,20 ;sleep %command_delay%
	return
	#IfWinActive

	;WatchForWindow code by DataLife
	;http://www.autohotkey.com/board/topic/88510-ufcpp-the-unofficial-fullscreen-command-prompt-patcher/#entry561599
	WatchForWindow:
	IfWinExist,Administrator: C:\Windows\system32\cmd.exe
	{
		SetTimer,WatchForWindow,off
		WinWaitActive,Administrator: C:\Windows\system32\cmd.exe
		ControlClick,Button1, A
	}
	return
	
	#IfWinActive ahk_class ConsoleWindowClass
		~LButton Up::
			if (MaxButtonFS)
			{
				mStateChk:=0
				SetTimer,mStateCheck,20
			}
		return
	#IfWinActive
;------------------------------------------------;}

;[other_func];{
;------------------------------------------------------
mStateCheck:
	mStateChk+=1
	
	WinGet, mState, MinMax, ahk_class ConsoleWindowClass ;ahk_pid %cPID%
	if (mState=1)
	{
		SetTimer,mStateCheck,Off
		mStateChk:=0
		;ToolTip Yep!
		WinRestore,ahk_class ConsoleWindowClass ;PostMessage, 0x112, 0xF120,,,ahk_class ConsoleWindowClass
		Sleep 250
		gosub, runfscreenr
	}
	else
	{
		if (mStateChk>4)
		{
			SetTimer,mStateCheck,Off
			mStateChk:=0
			;ToolTip Nope
		}
		
	}
return

FSCmdCheck:
	FSCmdChk+=1
	if (FSCmdChk > 4)
	{
		SetTimer,FSCmdCheck,off
		FSCmdChk:=0
	}
	
	if !WinExist("ahk_id " . currCMDoutEXIT_hwnd)
	{
		cmdfullscreen:=0
		SetTimer,FSCmdCheck,off
		FSCmdChk:=0
	}
return

setwindowwatchhandler:
	If (setwindowwatch)
		SetTimer,WatchForWindow,off
		
	setwindowwatch := (!setwindowwatch)
	menu, Submenu, ToggleCheck, Block FS unsupported Message
	IniWrite, %setwindowwatch%, %configfile%, UFCPP_Settings, Block_FS_NotSupported_Window
return

StartUp_Update_Check_handler:
	StartUp_Update_Check:=(!StartUp_Update_Check)
	menu, Submenu, ToggleCheck, Check for updates On Start Up
	IniWrite, %StartUp_Update_Check%, %configfile%, UFCPP_Settings, StartUp_Update_Check
return

fscmdopen:
	run, %ComSpec% /k cd `%userprofile`% &cls,,,tempcmdPID
	if ErrorLevel = ERROR
		goto fscmdopen
	WinWaitActive, ahk_pid %tempcmdPID%
	if ErrorLevel
	{
		MsgBox, 48, UFCPP - Error, ERROR: Could not find cmd window...
		return
	}
	gosub, runfscreenr
return

UseAutoRun_Config:
	UseAutoRun := (!UseAutoRun)
	setAutorun(UseAutoRun)
	IniWrite, %UseAutoRun%, %configfile%, UFCPP_Settings, UseAutoRun
	menu, Submenu, ToggleCheck, Run On Start Up (On Login)
return

Show_Scrollbar_config:
	Show_Scrollbar := (!Show_Scrollbar)
	IniWrite, %Show_Scrollbar%, %configfile%, UFCPP_Settings, Show_Scrollbar
	menu, Submenu, ToggleCheck, Show Scrollbar
return

MaxButtonFS_config:
	MaxButtonFS := (!MaxButtonFS)
	IniWrite, %MaxButtonFS%, %configfile%, UFCPP_Settings, MaxButtonFS
	menu, Submenu, ToggleCheck, Maximize Button to FullScreen
return
;------------------------------------------;}

;[GUI actions] ;{
;----------------------------------------------------------
	Screenbuffer_lines_config:
		inputbox,new_Screenbuffer_lines,Custom Screenbuffer lines Setting,Enter the number of lines for the Screenbuffer,,250,140
		if new_Screenbuffer_lines is not digit
		{
			MsgBox, 16, Invalid entry!, Only numbers may be entered...`nNothing was changed.
			return
		}
		
		If (new_Screenbuffer_lines != "") and (new_Screenbuffer_lines is digit) and (new_Screenbuffer_lines != Screenbuffer_lines) and (new_Screenbuffer_lines > 0)
		{
			menu, Submenu, Rename, Screenbuffer Lines (%Screenbuffer_lines%), Screenbuffer Lines (%new_Screenbuffer_lines%)
			Screenbuffer_lines := new_Screenbuffer_lines
			IniWrite, %Screenbuffer_lines%, %configfile%, UFCPP_Settings, Screenbuffer_lines
		}
	return

	aboutinfo:
		if !aboutguiopen
		{
			Gui, aboutgui:Color, 1A1A1A
			Gui, aboutgui: +hwndAboutG_h
			Gui, aboutgui:Font, s8 c55E439, Lucida Console
			Gui, aboutgui:Add, picture, w48 h48 gopentopic, %A_Temp%\cmdicon_x48.png
			Gui, aboutgui:Add, picture, w48 h48 y183 x10 gopensite, %A_Temp%\joedf-logo.png
			Gui, aboutgui:Add, Edit, w450 h228 x64 y5 +ReadOnly, %info%
			Gui, aboutgui:Add, text, x10 y50 w48 Center gopentopic,Project Site
			Gui, aboutgui:show, center, About UFCPP v%version%
			aboutguiopen:=!aboutguiopen
		}
		else
		{
			WinActivate, ahk_id %AboutG_h%
		}
	Return

	aboutguiGuiClose:
		Gui, aboutgui:Destroy
		aboutguiopen:=!aboutguiopen
	return
	
	HotkeySettingGUI:
	if !HotkeySettingGUIopen
	{
		Gui, +hwndHotkeyGUI ;+ToolWindow
		Gui, %HotkeyGUI%:Add, GroupBox, x6 y0 w240 h66 , Hotkeys
		Gui, %HotkeyGUI%:Add, Text, x16 y18 w60 h16 , Open Cmd
		HotkeyControl("OpenCMDKey",HotkeyGUI,"x76 y16 w100 h20 vOpenCMDKey",user_hotkey(OpenCMDKey),"Black",0)
		Gui, %HotkeyGUI%:Add, CheckBox, x186 y16 w50 h20 vOpenCMDKey_Enabled +Checked%OpenCMDKey_Enabled%, Enable
		Gui, %HotkeyGUI%:Add, Text, x16 y40 w60 h16 , Fullscreen
		HotkeyControl("FSKey",HotkeyGUI,"x76 y36 w100 h20 vFSKey",user_hotkey(FSKey),"Black",0)
		Gui, %HotkeyGUI%:Add, CheckBox, x186 y36 w50 h20 vFSKey_Enabled +Checked%FSKey_Enabled%, Enable
		Gui, %HotkeyGUI%:Add, Button, x46 y72 w80 h20 gHotkeyGUISave +Default, Save
		Gui, %HotkeyGUI%:Add, Button, x126 y72 w80 h20 gHotkeyGUIGuiClose, Cancel
		Gui, %HotkeyGUI%:Show, w253 h96, Hotkey Settings
		HotkeySettingGUIopen:=!HotkeySettingGUIopen
	}
	else
	{
		WinActivate, ahk_id %HotkeyGUI%
	}
	Return

	HotkeyGUISave:
		gui, %HotkeyGUI%:submit
		OpenCMDKey:=ahk_hotkey(OpenCMDKey)
		FSKey:=ahk_hotkey(FSKey)
		IniWrite,%OpenCMDKey_Enabled%,%configfile%,UFCPP_Settings,OpenCMDKey_Enabled
		IniWrite,%OpenCMDKey%,%configfile%,UFCPP_Settings,OpenCMDKey
		IniWrite,%FSKey_Enabled%,%configfile%,UFCPP_Settings,FSKey_Enabled
		IniWrite,%FSKey%,%configfile%,UFCPP_Settings,FSKey
		Reload ;apply settings
	HotkeyGUIGuiClose:
		Gui, %HotkeyGUI%:Destroy
		HotkeySettingGUIopen:=!HotkeySettingGUIopen
	return

	User_Hotkey(key) {
		
		mkey:=RegExReplace(key,"[!|\^||\+|#]")
		StringReplace,key,key,%mkey%,,All
		StringReplace,key,key,+,|,all
		loop, % (strlen(key)-1)
			okey:=okey substr(key,A_index,1) " + "
		okey:=okey substr(key,strlen(key),1)
		StringReplace,okey,okey,^,Ctrl,all
		StringReplace,okey,okey,!,Alt,all
		StringReplace,okey,okey,#,Win,all
		StringReplace,okey,okey,|,Shift,all
		okey:=okey " + " mkey
		StringUpper,okey,okey,T
		return okey
	}
	
	ahk_hotkey(key) {
		
		key:=RegExReplace(key,"[\s|\+]")
		key:=RegExReplace(key,"([LR]?Ctrl)|([LR]?Control)","^")
		key:=RegExReplace(key,"([LR]?Win)|([LR]?Windows)|([LR]?WinKey)","#")
		key:=RegExReplace(key,"([LR]?Alt)","!")
		key:=RegExReplace(key,"([LR]?Shift)","+")
		StringLower,key,key
		return key
	}
	
	GuiClose: ;Generic GuiClose - detect the gui, since HotkeyControl can not handle gui with a name and handle.
	winget,guiclose_id,ID,A
	if(guiclose_id==HotkeyGUI)
		gosub HotkeyGUIGuiClose
	else
		gui, destroy
	return
	
;-----------------------------------------------------;}

;[Simple Actions] ;{
;---------------------------------------------
	reloadprgm:
		Reload
	Return

	exitprgm:
		ExitApp
	return

	opentopic:
		run, http://ufcpp.sourceforge.net
	Return

	opensite:
		run, http://joedf.co.nr
	Return
	
	updatechk:
		update_program(Appname,Version,UpdateCheckLocation,"Browser","false","false")
	return
	
	cmdopen:
		run, %ComSpec% /k cd `%userprofile`% &cls
	return
;-------------------------------------------;}

setAutorun(query) {
	SplitPath,A_ScriptFullPath,,,,name_noext
	if (query) {
	FileCreateShortcut,"%A_ScriptFullPath%",%A_Startup%\%name_noext%.lnk
	} else {
	FileDelete, %A_Startup%\%name_noext%.lnk
	}
}

strlower(string) {
	StringLower,string,string
	return string
}

update_program(AppName,CurrentVersion,UpdateCheckLocation,OpenMethod="Download",SilentMode="true",Confirm="false") {
	TmpFile=%A_TEMP%\%AppName%_updater.TMP
	UrlDownloadToFile,%UpdateCheckLocation%,%TmpFile%

	FileReadLine,NewVersion,%TmpFile%,1
	FileReadLine,NewVDownld,%TmpFile%,2
	FileDelete,%TmpFile%

	if Newversion in %CurrentVersion%
	{
		if SilentMode != true
		{
			MsgBox,64,%Appname% Updater, No updates found.
		}
	}
	Else
	{
		if OpenMethod = download
		{
			MsgBox,68,%Appname% Updater, Updates found.`nCurrent: %CurrentVersion% `nNewest: %NewVersion% `nDownload now?
			IfMsgBox Yes
			{
				FileSelectFile, DnlWhere ,s, RootDir\%AppName%_v%NewVersion%, Save As...,Application (*.exe)
				Dnlwhere = %DnlWhere%.exe
				if Dnlwhere = .exe
				{
					MsgBox,64,%Appname% Updater,Download Canceled.
				}
				Else
				{
					TrayTip,%AppName% Updater,You will be notified when the download is finished.,15,1
					UrlDownloadToFile,%NewVDownld%,%DnlWhere%
					MsgBox,64,%Appname% Updater,Download Finished.
				}
			}
			Else
			{
				if Confirm != false
				{
					MsgBox,64,%Appname% Updater, Update Canceled.
				}
				return
			}
		}
		Else
		{
			MsgBox,68,%Appname% Updater, Updates found.`nCurrent: %CurrentVersion% `nNewest: %NewVersion% `nOpen in Webbrowser?
			IfMsgBox Yes
			{
				Run, %NewVDownld%
			}
			Else
			{
				if Confirm != false
				{
					MsgBox,64,%Appname% Updater, Update Canceled.
				}
				return
			}
		}
	}
}


